import { IReduxAction } from '../../interfaces';
import { ReduxActionFunc } from '../action/action';
export declare type ReduxReducerFunc<S, P> = (state: S, action?: IReduxAction<P>) => S;
export declare type ReduxReducerDecorator<S, P> = (target: object, propertyKey: string | symbol, descriptor: TypedPropertyDescriptor<ReduxReducerFunc<S, P>>) => TypedPropertyDescriptor<ReduxReducerFunc<S, P>>;
export declare type ReduxReducerActionType<P> = ReduxActionFunc<Promise<P>> | ReduxActionFunc<P> | string;
export declare type ReduxReducerActionTypeArray<P> = ReduxReducerActionType<P> | Array<ReduxReducerActionType<P>>;
export interface IReduxReducerClassMetadata {
    reducers: Array<{
        types: ReduxReducerActionTypeArray<{}>;
        reducer: ReduxReducerFunc<{}, {}>;
    }>;
}
export declare function ReduxReducer<S = any, P = any>(types: ReduxReducerActionTypeArray<P>): ReduxReducerDecorator<S, P>;
export declare function getReduxReducerClassMetadata(target: any): IReduxReducerClassMetadata;
